

// Test all range variants.

#include <stdio.h>
#include <string.h>

#include "ad++.h"


const int n_cases = 28 ;

const int n = 50 ;

Range sample(char* desc, Dimension d, int i_case) {
  Range x ;

  switch(i_case) {
    case 0 :
      x = Range(n) ;
      strcpy(desc, "Range(n)") ;
      break ;
    case 1 :
      x = BlockRange(n, d) ;
      strcpy(desc, "BlockRange(n, d)") ;
      break ;
    case 2 :
      x = CyclicRange(n, d) ;
      strcpy(desc, "CyclicRange(n, d)") ;
      break ;
    case 3 :
      x = StepRange(n, d) ;
      strcpy(desc, "StepRange(n, d)") ;
      break ;
    case 4 :
      //x = BlockRange(d, 12).subrng(n) ;
      //strcpy(desc, "BlockRange(d, 12).subrng(n)") ;
      x = BlockRange(n, d, 12) ;
      strcpy(desc, "BlockRange(n, d, 12)") ;
      break ;
    case 5 : {
      //const int nblks = (n + 4 - 1) / 4 ;
      //x = BlockRange(n, CyclicRange(nblks, d)) ;
      //sprintf(desc, "BlockRange(n, CyclicRange(%d, d))", nblks) ;
      x = BlockCyclicRange(n, d, 4) ;
      strcpy(desc, "BlockCyclicRange(n, d, 4)") ;
      break ;
    }
    case 6 :
      x = Range(400).subrng(n, 100, 5) ;
      strcpy(desc, "Range(400).subrng(n, 100, 5)") ;
      break ;
    case 7 :
      x = Range(250).subrng(n, 225, -4) ;
      strcpy(desc, "Range(250).subrng(n, 225, -4)") ;
      break ;
    case 8 :
      x = BlockRange(400, d).subrng(n, 100, 5) ;
      strcpy(desc, "BlockRange(400, d).subrng(n, 100, 5)") ;
      break ;
    case 9 :
      x = BlockRange(400, d, LAY_PACKED).subrng(n, 100, 5) ;
      strcpy(desc, "BlockRange(400, d, LAY_PACKED).subrng(n, 100, 5)") ;
      break ;
    case 10 :
      x = BlockRange(250, d).subrng(n, 225, -4) ;
      strcpy(desc, "BlockRange(250, d).subrng(n, 225, -4)") ;
      break ;
    case 11 :
      x = BlockRange(250, d, LAY_PACKED).subrng(n, 225, -4) ;
      strcpy(desc, "BlockRange(250, d, LAY_PACKED).subrng(n, 225, -4)") ;
      break ;
    case 12 :
      x = CyclicRange(400, d).subrng(n, 100, 5) ;
      strcpy(desc, "CyclicRange(400, d).subrng(n, 100, 5)") ;
      break ;
    case 13 :
      x = CyclicRange(400, d, LAY_ADAPT).subrng(n, 100, 5) ;
      strcpy(desc, "CyclicRange(400, d, LAY_ADAPT).subrng(n, 100, 5)") ;
      break ;
    case 14 :
      x = CyclicRange(250, d).subrng(n, 225, -4) ;
      strcpy(desc, "CyclicRange(250, d).subrng(n, 225, -4)") ;
      break ;
    case 15 :
      x = CyclicRange(250, d, LAY_ADAPT).subrng(n, 225, -4) ;
      strcpy(desc, "CyclicRange(250, d, LAY_ADAPT).subrng(n, 225, -4)") ;
      break ;
    case 16 :
      x = StepRange(400, d).subrng(n, 100, 5) ;
      strcpy(desc, "StepRange(400, d).subrng(n, 100, 5)") ;
      break ;
    case 17 :
      x = StepRange(400, d, LAY_PACKED).subrng(n, 100, 5) ;
      strcpy(desc, "StepRange(400, d, LAY_PACKED).subrng(n, 100, 5)") ;
      break ;
    case 18 :
      x = StepRange(250, d).subrng(n, 225, -4) ;
      strcpy(desc, "StepRange(250, d).subrng(n, 225, -4)") ;
      break ;
    case 19 :
      x = StepRange(250, d, LAY_PACKED).subrng(n, 225, -4) ;
      strcpy(desc, "StepRange(250, d, LAY_PACKED).subrng(n, 225, -4)") ;
      break ;
    case 20 :
      //x = BlockRange(d, 120).subrng(400).subrng(n, 100, 5) ;
      //strcpy(desc, "BlockRange(d, 120).subrng(400).subrng(n, 100, 5)") ;
      x = BlockRange(400, d, 120).subrng(n, 100, 5) ;
      strcpy(desc, "BlockRange(400, d, 120).subrng(n, 100, 5)") ;
      break ;
    case 21 :
      //x = BlockRange(d, 60).subrng(250).subrng(n, 225, -4) ;
      //strcpy(desc, "BlockRange(d, 60).subrng(250).subrng(n, 225, -4)") ;
      x = BlockRange(250, d, 60).subrng(n, 225, -4) ;
      strcpy(desc, "BlockRange(250, d, 60).subrng(n, 225, -4)") ;
      break ;
    case 22 : {
      //const int nblks = (400 + 24 - 1) / 24 ;
      //x = BlockRange(400, CyclicRange(nblks, d)).subrng(n, 100, 5) ;
      //sprintf(desc,
      //        "BlockRange(400, CyclicRange(%d, d)).subrng(n, 100, 5)",
      //        nblks) ;
      x = BlockCyclicRange(400, d, 24).subrng(n, 100, 5) ;
      strcpy(desc, "BlockCyclicRange(400, d, 24).subrng(n, 100, 5)") ;
      break ;
    }
    case 23 : {
      //const int nblks = (250 + 17 - 1) / 17 ;
      //x = BlockRange(250, CyclicRange(nblks, d)).subrng(n, 225, -4) ;
      //sprintf(desc,
      //        "BlockRange(250, CyclicRange(%d, d)).subrng(n, 225, -4)",
      //        nblks) ;
      x = BlockCyclicRange(250, d, 17).subrng(n, 225, -4) ;
      strcpy(desc, "BlockCyclicRange(250, d, 17).subrng(n, 225, -4)") ;
      break ;
    }
    case 24 : {
      //const int nblks = (400 + 24 - 1) / 24 ;
      //x = BlockRange(400, CyclicRange(nblks, d), LAY_PACKED).subrng(n, 100, 5) ;
      //sprintf(desc,
      //        "BlockRange(400, CyclicRange(%d, d), LAY_PACKED).subrng(n, 100, 5)",
      //        nblks) ;
      x = BlockCyclicRange(400, d, 24, LAY_PACKED).subrng(n, 100, 5) ;
      strcpy(desc,
             "BlockCyclicRange(400, d, 24, LAY_PACKED).subrng(n, 100, 5)") ;
      break ;
    }
    case 25 : {
      //const int nblks = (250 + 17 - 1) / 17 ;
      //x = BlockRange(250, CyclicRange(nblks, d), LAY_PACKED).subrng(n, 225, -4) ;
      //sprintf(desc,
      //        "BlockRange(250, CyclicRange(%d, d), LAY_PACKED).subrng(n, 225, -4)",
      //        nblks) ;
      x = BlockCyclicRange(250, d, 17, LAY_PACKED).subrng(n, 225, -4) ;
      strcpy(desc,
             "BlockCyclicRange(250, d, 17, LAY_PACKED).subrng(n, 225, -4)") ;
      break ;
    }
    case 26 : {
      //const int nblks = (400 + 24 - 1) / 24 ;
      //x = BlockRange(400, CyclicRange(nblks, d, LAY_ADAPT), LAY_PACKED).
      //        subrng(n, 100, 5) ;
      //sprintf(desc,
      //        "BlockRange(400, CyclicRange(%d, d, LAY_ADAPT), LAY_PACKED)."
      //        "subrng(n, 100, 5)",
      //        nblks) ;
      x = BlockCyclicRange(400, d, 24, LAY_ADAPT).subrng(n, 100, 5) ;
      strcpy(desc,
             "BlockCyclicRange(400, d, 24, LAY_ADAPT).subrng(n, 100, 5)") ;
      break ;
    }
    case 27 : {
      //const int nblks = (250 + 17 - 1) / 17 ;
      //x = BlockRange(250, CyclicRange(nblks, d, LAY_ADAPT), LAY_PACKED).
      //        subrng(n, 225, -4) ;
      //sprintf(desc,
      //        "BlockRange(250, CyclicRange(%d, d, LAY_ADAPT), LAY_PACKED)."
      //        "subrng(n, 225, -4)",
      //        nblks) ;
      x = BlockCyclicRange(250, d, 17, LAY_ADAPT).subrng(n, 225, -4) ;
      strcpy(desc,
             "BlockCyclicRange(250, d, 17, LAY_ADAPT).subrng(n, 225, -4)") ;
      break ;
    }
  }
  return x ;
}

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  char xDesc [1024], yDesc [1024] ;

  Procs1 p(6) ;
  Dimension d = p.dim(0) ;

  for(int i = 0 ; i < n_cases ; i++) {
    Range x = sample(xDesc, d, i) ;
    for(int j = 0 ; j < n_cases ; j++) {
      Range y = sample(yDesc, d, j) ;

      gprintf("x = %s\n", xDesc) ;
      gprintf("y = %s\n", yDesc) ;

      Array1<float> a(x, p) ;
      Array1<float> b(y, p) ;
      Array1<int> mask1(y, p), mask2(y, p) ;

      ON(p) {
        Index i(x) ;
	OVERALL(i) {
	  a(i) = i ;
	} ALLOVER(i) ;
      } NO(p) ;

      remap(b, a) ;

      ON(p) {
        Index i(y) ;
	OVERALL(i) {
	  mask1(i) = b(i) == i ;
	  mask2(i) = b(i) != i ;
	} ALLOVER(i) ;
      } NO(p) ;

      if(!all(mask1) || any(mask2))
	    // Do both checks to reduce chance of bug in reductions.
        aprintf("%2R0%f\n", b) ;
      else
	gprintf("Checked OK\n") ;

    //aprintf("%2R0%4d\n", b) ;
    }
  }

  AdlibFinalize() ;
}


